import random
import math
random.seed("personal06/card-game")

class TestGen:
    def __init__(self):
        self.test_number = 0

    def generate_samples(self):
        self.print_test(6, 4)

    def generate_min_tests(self):
        self.print_test(2, 2)
        self.print_test(2, 0)
        self.print_test(4, 0)
        self.print_test(4, 2)
        self.print_test(4, 4)
        self.print_test(6, 0)
        self.print_test(6, 2)
        self.print_test(6, 6)

    def generate_hand_tests(self):
        pass

    def generate_random_test(self, minn, maxn):
        n = random.randint(minn // 2, maxn // 2) * 2
        k = random.randint(0, n // 2) * 2
        self.print_test(n, k)

    def generate_max_tests(self, maxn):
        #maxn = 100
        for i in range(3):
            n = maxn
            k = random.randint(1, maxn // 2 - 1) * 2
            self.print_test(n, k)
        self.print_test(maxn, maxn)
        self.print_test(maxn, 0)
        self.print_test(maxn, maxn // 2)
        self.print_test(maxn, maxn // 4 + 1)

    def print_test(self, n, k):
        self.test_number += 1
        print('Generating test #%d' % self.test_number)
        test_name = "{0:0=2d}".format(self.test_number)
        test_file = open(test_name, 'w')
        print(n, k, file=test_file)
        test_file.close()

    def generate_all_tests(self):
        self.generate_samples()
        self.generate_min_tests()
        self.generate_hand_tests()
        for n in [10, 20, 30, 40, 50, 60, 70, 80, 90, 100]:
            for i in range(2):
                self.generate_random_test(max(8, n - 10), n)
        self.generate_max_tests(100)

import time
start = time.time()
writer = TestGen()
writer.generate_all_tests()
finish = time.time()
print('All tests were generated. Elapsed time: ', finish - start)
