import random
import math
random.seed("basic05/events")

class TestGen:
    def __init__(self):
        self.test_number = 0

    def generate_samples(self):
        self.print_test([1, 3, 4], [1, 2, 3, 4, 5, 6])

    def generate_min_tests(self):
        self.print_test([1], [1])
        self.print_test([1], [2])
        self.print_test([2**29 - 1, 2**15], [2**15])
        self.print_test([2**29 - 1, 2**15], [2**14])

    def generate_zero_tests(self):
        self.print_test([1, 2], [0])
        self.print_test([1, 3], [0])        
        self.print_test([0], [0])
        self.print_test([2**29 - 1 - 2**15, 2**15], [0])
        self.print_test([2**29 - 1 - 2**15, 2**14, 2**15], [0, 1, 2, 4, 5])
        self.print_test([0, 1, 3, 4], [0, 1, 2, 4, 5, 6, 7, 8, 9, 10])
        self.print_test([0], [0, 0, 0, 0, 0, 0, 0])

    def generate_hand_tests(self):
        pass

    def generate_random_test(self, n, maxv):
        sa = set()
        a = []
        for i in range(n):
            x = random.randint(1, maxv)
            while x in sa:
                x = random.randint(1, maxv)
            sa.add(x)
            a.append(x)
        if maxv <= 10**5:
            b = []
            cur = 1
            for i in range(10**5):
                b.append(cur)
                cur += 1
                if cur == maxv + 1:
                    cur = 1
            random.shuffle(b)
        else:
            b = [random.randint(1, maxv) for _ in range(10**5)]
        self.print_test(a, b)

    def generate_max_tests(self, maxn, maxq, maxv):
        self.print_test([i for i in range(maxn)], [i for i in range(maxq)])
        self.print_test([(maxv - i) for i in range(maxn)], [i for i in range(maxq)])
        self.print_test([i for i in range(maxn)], [(maxv - i) for i in range(maxq)])
        self.print_test([(maxv - i) for i in range(maxn)], [(maxv - i) for i in range(maxq)])
        self.print_test([i for i in range(100)], [i for i in range(maxq)])
        a = [i for i in range(maxq)]
        random.shuffle(a)
        self.print_test([i for i in range(2**16)], a)
        a = [0, 1, 2, 3, 4, 5]
        for i in range(3, 29):
            a.append(2**i - 1)
            a.append(2**i)
            a.append(2**i + 1)
        random.shuffle(a)
        b = []
        B = 10**4
        for i in range(1, 10**9 // (B * 3)):
            b.append(i * B - 1)
            b.append(i * B)
            b.append(i * B + 1)
        random.shuffle(b)
        self.print_test(a, b)

    def print_test(self, a, b):
        self.test_number += 1
        print('Generating test #%d' % self.test_number)
        test_name = "{0:0=2d}".format(self.test_number)
        test_file = open(test_name, 'w')
        print(len(a), file=test_file)
        print(' '.join(map(str, a)), file=test_file)
        print(len(b), file=test_file)
        print(' '.join(map(str, b)), file=test_file)
        test_file.close()

    def generate_all_tests(self):
        self.generate_samples()
        self.generate_min_tests()
        self.generate_hand_tests()
        for n in [3, 5, 10]:
            for maxv in [5, 10, 100, 10**5]:
                if maxv < n:
                    continue
                for _ in range(2):
                    self.generate_random_test(n, maxv)
        self.generate_zero_tests()
        for n in [100, 10**3, 10**5]:
            for maxv in [1000, 10**5, 10**9]:
                if maxv < n:
                    continue
                for _ in range(2):
                    self.generate_random_test(n, maxv)
        self.generate_max_tests(10**5, 10**5, 10**9)

import time
start = time.time()
writer = TestGen()
writer.generate_all_tests()
finish = time.time()
print('All tests were generated. Elapsed time: ', finish - start)
