#include "bits/stdc++.h"
#define ff first
#define ss second
#define szof(_x) ((int) (_x).size())
#define TASK_NAME ""
#ifdef LOCAL
#  define _GLIBCXX_DEBUG
#  define _GLIBCXX_DEBUG_PEDANTIC
#endif

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const ll INFL = 1e18 + 123;
const double PI = atan2(0, -1);
mt19937 tw(960172);
ll rnd(ll x, ll y) { static uniform_int_distribution<ll> d; return d(tw) % (y - x + 1) + x; }

const int SZ = 4;

struct node {
	int l, r;
	vector<ll> arr;
	char val;
	bool reversed;
	ll sz;
	node() : l(0), r(0), arr(SZ * SZ), reversed(false), sz(0) {}
	node(char _val) : l(0), r(0), arr(SZ * SZ), val(_val), reversed(false), sz(1) {
		for (int i = 0; i <= val; ++i) {
			for (int j = val; j < SZ; ++j) {
				arr[i * SZ + j] = 1;
				arr[j * SZ + i] = 1;
			}
		}
	}
	//node(node const& other) : l(other.l), r(other.r), arr(other.arr), val(other.val), reversed(other.reversed), sz(other.sz) {}
};

const int SZ_TREAP = 6e6;

node treap[SZ_TREAP];
int last_node = 0;

ll get_len(int v, int i, int j) {
	if (!treap[v].reversed) {
		return treap[v].arr[i * SZ + j];
	}
	return treap[v].arr[j * SZ + i];
}

ll get_max(int v) {
	return get_len(v, 0, SZ - 1);
}

int get_copy(int v) {
	assert(last_node < SZ_TREAP);
	//cerr << v << endl;
	//treap.push_back(treap[v]);
	treap[last_node++] = treap[v];
	return last_node - 1;
}

void update(int v) {
	int vl = treap[v].l, vr = treap[v].r;
	//treap[v].reversed = false;
	assert(!treap[v].reversed);
	fill(treap[v].arr.begin(), treap[v].arr.end(), 0);
	auto& m = treap[v].arr;
	for (int i = 0; i < SZ; ++i) {
		for (int j = i; j < SZ; ++j) {
			for (int k = j; k < SZ; ++k) {
				m[i * SZ + k] = max(get_len(vl, i, j) + get_len(vr, j, k), m[i * SZ + k]);
				m[k * SZ + i] = max(get_len(vl, k, j) + get_len(vr, j, i), m[k * SZ + i]);
			}
		}
	}
	int val = treap[v].val;
	for (int i = 0; i <= val; ++i) {
		for (int j = val; j < SZ; ++j) {
			m[i * SZ + j] = max(get_len(vl, i, val) + 1 + get_len(vr, val, j), m[i * SZ + j]);
			m[j * SZ + i] = max(get_len(vl, j, val) + 1 + get_len(vr, val, i), m[j * SZ + i]);
		}
	}
	treap[v].sz = treap[vl].sz + 1 + treap[vr].sz;
}

void t_propogate(int v) {
	if (!treap[v].reversed) {
		return;
	}

	if (treap[v].l) {
		treap[v].l = get_copy(treap[v].l);
		treap[treap[v].l].reversed ^= 1;
	}
	if (treap[v].r) {
		treap[v].r = get_copy(treap[v].r);
		treap[treap[v].r].reversed ^= 1;
	}
	swap(treap[v].l, treap[v].r);
	treap[v].reversed = false;
}

void print(int v, bool reversed = false) {
	if (!v) {
		return;
	}
	cerr << "(";
	if (reversed ^ treap[v].reversed) {
		print(treap[v].r, true);
		cerr << (int) treap[v].val;
		print(treap[v].l, true);
	} else {
		print(treap[v].l, false);
		//cerr << string(d, ' ') << (int) treap[v].val << endl;
		//cerr << "(" << v << ", " << (int) treap[v].val << ") ";
		cerr << (int) treap[v].val;
		print(treap[v].r, false);
	}
	cerr << ")";
}

pii t_split(int v, ll len) {
	if (!v) {
		return {0, 0};
	}

	v = get_copy(v);
	t_propogate(v);
	
	if (treap[treap[v].l].sz < len) {
		int vl = v, vr;
		auto tmp = t_split(treap[v].r, len - treap[treap[v].l].sz - 1);
		tie(treap[vl].r, vr) = tmp;
		update(vl);
		return {vl, vr};
	} else {
		int vl, vr = v;
		auto tmp = t_split(treap[v].l, len);
		tie(vl, treap[vr].l) = tmp;
		update(vr);
		return {vl, vr};
	}
}

int t_merge(int vl, int vr) {
	if (!vl) {
		return vr;
	}
	if (!vr) {
		return vl;
	}
	if (rnd(0, treap[vl].sz + treap[vr].sz - 1) < treap[vl].sz) {
		int v = get_copy(vl);
		t_propogate(v);
		int tmp = t_merge(treap[v].r, vr);
		treap[v].r = tmp;
		update(v);
		return v;
	} else {
		int v = get_copy(vr);
		t_propogate(v);
		int tmp = t_merge(vl, treap[v].l);
		treap[v].l = tmp;
		update(v);
		return v;
	}
}

void t_merge_not_persistant(int vl, int vr, int& v) {
	if (!vl) {
		v = vr;
		return;
	}
	if (!vr) {
		v = vl;
		return;
	}
	if (rnd(0, treap[vl].sz + treap[vr].sz - 1) < treap[vl].sz) {
		t_merge_not_persistant(treap[vl].r, vr, treap[vl].r);
		v = vl;
		update(v);
	} else {
		t_merge_not_persistant(vl, treap[vr].l, treap[vr].l);
		v = vr;
		update(v);
	}
}

int duplicate(int v, ll k) {
	int ret = 0;
	while (k) {
		if (k & 1) {
			ret = t_merge(ret, v);
		}
		v = t_merge(v, v);
		k >>= 1;
	}
	return ret;
}

int build_string(string s) {
	int ret = 0;
	for (char c : s) {
		//treap.push_back(node(c - '0'));
		assert(last_node < SZ_TREAP);
		treap[last_node++] = node(c - '0');
		t_merge_not_persistant(ret, last_node - 1, ret);
	}
	return ret;
}

void solve() {
	//treap.push_back(node());
	treap[last_node++] = node();

	string s;
	cin >> s;
	int root = build_string(s);

	cout << get_max(root) << "\n";

	int q;
	cin >> q;
	for (int i = 0; i < q; ++i) {
		//cerr << i << " " << szof(treap) << endl;
		//cerr << "i: " << i << endl;
		int t;
		cin >> t;

		// 1 -- insert pos w
		// 2 -- erase pos l
		// 3 -- reverse pos l
		// 4 -- clone pos l k

		if (t == 1) {
			ll pos;
			string w;
			cin >> pos >> w;
			int cur = build_string(w);
			int l, r;
			tie(l, r) = t_split(root, pos);
			l = t_merge(l, cur);
			root = t_merge(l, r);
		} else if (t == 2) {
			ll pos, len;
			cin >> pos >> len;
			int l, m, r;
			tie(l, r) = t_split(root, pos);
			tie(m, r) = t_split(r, len);
			root = t_merge(l, r);
		} else if (t == 3) {
			ll pos, len;
			cin >> pos >> len;
			int l, m, r;
			tie(l, r) = t_split(root, pos);
			tie(m, r) = t_split(r, len);
			m = get_copy(m);
			treap[m].reversed = 1;
			l = t_merge(l, m);
			root = t_merge(l, r);
		} else {
			ll pos, len, k;
			cin >> pos >> len >> k;
			int l, m, r;
			tie(l, r) = t_split(root, pos);
			tie(m, r) = t_split(r, len);
			m = duplicate(m, k + 1);
			l = t_merge(l, m);
			root = t_merge(l, r);
		}

		//print(root); cerr << endl;
		cout << get_max(root) << "\n";
	}
	//cerr << szof(treap) << endl;
}


int main() {
	//freopen("test", "r", stdin);
	//freopen(TASK_NAME ".out", "w", stdout);
	cerr << fixed << setprecision(15);
	cout << fixed << setprecision(15);
	ios::sync_with_stdio(false);

	int tests = 1;
	// cin >> tests;
	for (int it = 1; it <= tests; ++it) {
		solve();
	}
	
	#ifdef LOCAL
		cerr << "time: " << clock() << " ms\n";
	#endif
	return 0;
}