#include <cstdio>
#include <iostream>
#include <cassert>
#include <vector>
#include <map>
#include <string>
#include <algorithm>
#include <sstream>
#include "testlib.h"

using namespace std;

int cur_test = -1;
const int MAXN = 1e5;
const int MAXX = 1e9;
const int MAXA = 100;

string itoa(int x) 
{
    stringstream ss;
    string s;
    ss << x;
    ss >> s;
    return s;
}

int atoi(string s) 
{
    stringstream ss;
    int x;
    ss << s;
    ss >> x;
    return x;
}

void write_test(vector<int> a, vector<int> x) 
{
    startTest(cur_test++);
    cerr << cur_test << endl;
    int n = a.size();
    cout << n << endl;
    for (int i = 0; i < n; i++)
        cout << a[i] << ((i < n - 1) ? ' ' : '\n');
    for (int i = 0; i < n; i++)
        cout << x[i] << ((i < n - 1) ? ' ' : '\n');
}

void gen_rand(int n, int maxa, int maxx)
{
    vector<int> a(n), x(n);
    for (int i = 0; i < n; i++)
        a[i] = rnd.next(1, maxa);
    for (int i = 0; i < n; i++)
        x[i] = rnd.next(1, maxx);
    sort(x.begin(), x.end());
    write_test(a, x);
}

void gen_max(int n, int maxa, int maxx)
{
    vector<int> a(n), x(n);
    for (int i = 0; i < n; i++)
        a[i] = maxa;
    for (int i = 0; i < n; i++)
        x[i] = rnd.next(1, maxx);
    sort(x.begin(), x.end());
    write_test(a, x);
}


int main(int argc, char * argv[]) 
{
    registerGen(argc, argv, 1);
    cur_test = atoi(argv[1]);
    for (int i = 10; i <= MAXN; i *= 10)
    {
        gen_rand(i, 1, i * 10);
        gen_rand(i, 10, 10);
        gen_rand(rnd.next(i / 10, i), 10, MAXX);    
        gen_rand(rnd.next(i / 10, i), MAXA, MAXX);
        gen_rand(rnd.next(i / 10, i), MAXA, i);
    }
    gen_max(MAXN, 1, MAXX);
    gen_max(MAXN, MAXA, MAXX);
    return 0;
}