/**
 *    author:  [itmo] enot110
**/
#include <bits/stdc++.h>
#include "testlib.h"

#define F first
#define S second
#define pb push_back
#define forn(i, n) for(int i = 0 ; (i) < (n) ; ++i)
#define eprintf(...) fprintf(stderr, __VA_ARGS__),fflush(stderr)
#define sz(a) ((int)(a).size())
#define all(a) (a).begin(),a.end()
#define pw(x) (1LL<<(x))

using namespace std;

typedef long long ll;
typedef double dbl;
typedef vector<int> vi;
typedef pair<int, int> pi;

const dbl eps = 1e-9;

int cur_test = -1;

void shuffle(int *a, int *an)
{
    int n = an - a;
    forn(i, n)
    {
        int k = rnd.next(0, i);
        swap(a[k], a[i]);
    }
}

int solve(vi v1, vi v2, vi v3)
{
    int n = sz(v1);
    vector<vi> a(n, vi(3));
    auto f = [&](int x, int y)
    {
        int val = 0;
        forn(i, 3) val += a[x][i] < a[y][i];
        return val >= 2;
    };
    forn(i, n) a[v1[i] - 1][0] = i;
    forn(i, n) a[v2[i] - 1][1] = i;
    forn(i, n) a[v3[i] - 1][2] = i;

    int res = 0;
    for (int i = 1; i < n; ++i) if (f(i, res)) res = i;
    forn(i, n) if (i != res && !f(res, i)) return -1;
    return res + 1;
}


void write_test(vi v1, vi v2, vi v3) 
{
    startTest(cur_test);
    cerr << cur_test << endl;
    cur_test++;
    int n = sz(v1);
    printf("%d\n", n);
    forn(i, n) printf("%d%c", v1[i], " \n"[i + 1 == n]);
    forn(i, n) printf("%d%c", v2[i], " \n"[i + 1 == n]);
    forn(i, n) printf("%d%c", v3[i], " \n"[i + 1 == n]);
}

void random_test(int n)
{
    vi v[3];
    forn(i, 3)
    {
        forn(j, n) v[i].pb(j + 1);
        forn(j, n)
        {
            int k = rnd.next(0, j);
            swap(v[i][j], v[i][k]);
        }
    }
    write_test(v[0], v[1], v[2]);
}

void complete(int n, vi &v)
{
    vi p(n + 1);
    for (int x : v) p[x] = 1;
    vi z;
    for (int i = 1; i <= n; ++i) if (!p[i]) z.pb(i);
    shuffle(all(z));
    for (int x : z) v.pb(x);
}

void random_ok(int n)
{
    int winner = rnd.next(1, n);
    int cnt = rnd.next(0, n - 1);
    vi p;
    for (int i = 1; i <= n; ++i) if (i != winner) p.pb(i);
    shuffle(p.begin(), p.end());
    int cnt1 = rnd.next(0, cnt);
    int cnt2 = rnd.next(0, cnt);
    if (cnt1 > cnt2) swap(cnt1, cnt2);
    cnt2 -= cnt1;
    int cnt3 = cnt - cnt1 - cnt2;

    vi v1, v2, v3;
    int pos = 0;
    forn(i, cnt1) v1.pb(p[pos++]);
    forn(i, cnt2) v2.pb(p[pos++]);
    forn(i, cnt3) v3.pb(p[pos++]);
    assert(pos == cnt);
    v1.pb(winner);
    v2.pb(winner);
    v3.pb(winner);
    complete(n, v1);
    complete(n, v2);
    complete(n, v3);
    write_test(v1, v2, v3);

    assert(sz(v1) == n);
    assert(sz(v2) == n);
    assert(sz(v3) == n);
    /*forn(i, n) eprintf("%d%c", v1[i], " \n"[i + 1 == n]);
    forn(i, n) eprintf("%d%c", v2[i], " \n"[i + 1 == n]);
    forn(i, n) eprintf("%d%c", v3[i], " \n"[i + 1 == n]);


    eprintf("winner = %d\n", winner);
    eprintf("solve = %d\n", solve(v1, v2, v3));*/
    //assert(solve(v1, v2, v3) == winner);
}

void random_test2(int n)
{
    int z = n * 2 / 3;
    vi v[3];
    forn(i, 3)
    {
        for (int j = 1; j <= n; ++j) v[i].pb(j);
        shuffle(v[i].begin(), v[i].begin() + z);
        shuffle(v[i].begin() + z, v[i].end());
    }
    write_test(v[0], v[1], v[2]);
}    

void test_reverse(int n)
{
    vi v[3];
    forn(i, 3)
    {
        for (int j = 1; j <= n; ++j) v[i].pb(j);
        if (i) reverse(all(v[i]));
    }
    write_test(v[0], v[1], v[2]);
}            

void random_diag(int n)
{
    vi p;
    for (int i = 1; i <= n; ++i) p.pb(i);
    shuffle(all(p));
    vi v[3];
    forn(i, 3)
    {
        forn(j, n) v[i].pb(p[(i + j) % n]);
    }
    write_test(v[0], v[1], v[2]);
}
void straight_diag(int n)
{
    vi p;
    for (int i = 1; i <= n; ++i) p.pb(i);
    vi v[3];
    forn(i, 3)
    {
        forn(j, n) v[i].pb(p[(i + j) % n]);
    }
    write_test(v[0], v[1], v[2]);
}
void reversed_diag(int n)
{
    vi p;
    for (int i = 1; i <= n; ++i) p.pb(n + 1 - i);
    vi v[3];
    forn(i, 3)
    {
        forn(j, n) v[i].pb(p[(i + j) % n]);
    }
    write_test(v[0], v[1], v[2]);
}
void izban1(int n)
{
    vi v[3];
    forn(i, n) v[0].pb(i + 1);
    forn(i, n) v[1].pb(i + 1);
    v[2].pb(n);
    v[2].pb(n/2);
    for (int i = 2; i < n; ++i) v[2].pb(v[2][i - 2] - 1);
    write_test(v[0], v[1], v[2]);
}    

void izban2(int n)
{
    vi v[3];
    forn(i, n) v[0].pb(i + 1);
    forn(i, n) v[1].pb(i + 1);
    v[2].pb(n);
    v[2].pb(n/2);
    for (int i = 2; i < n; ++i) v[2].pb(v[2][i - 2] - 1);
    forn(i, 3) forn(j, n) v[i][j] = n + 1 - v[i][j];

    write_test(v[0], v[1], v[2]);
}    
void izban3(int n)
{
    vi v[3];
    n--;
    forn(i, n) v[0].pb(i + 1);
    forn(i, n) v[1].pb(i + 1);
    v[2].pb((n + 1) / 2);
    v[2].pb(n);
    for (int i = 2; i < n; ++i) v[2].pb(v[2][i - 2] - 1);
    
    v[0].insert(v[0].begin(), n + 1);
    v[1].insert(v[1].begin() + n, n + 1);
    v[2].insert(v[2].begin() + n - 1, n + 1);
    n++;
    
    write_test(v[0], v[1], v[2]);

}    

void izban4(int n)
{
    vi v[3];
    n--;
    forn(i, n) v[0].pb(i + 1);
    forn(i, n) v[1].pb(i + 1);
    v[2].pb((n + 1) / 2);
    v[2].pb(n);
    for (int i = 2; i < n; ++i) v[2].pb(v[2][i - 2] - 1);
    
    v[0].insert(v[0].begin(), n + 1);
    v[1].insert(v[1].begin() + n, n + 1);
    v[2].insert(v[2].begin() + n - 1, n + 1);
    n++;
    
    forn(i, 3) forn(j, n) v[i][j] = n + 1 - v[i][j];

    write_test(v[0], v[1], v[2]);
}    

int main(int argc, char * argv[]) 
{
    registerGen(argc, argv, 1);
    cur_test = atoi(argv[1]);

    eprintf("samples\n");
    write_test({1, 2, 3}, {2, 3, 1}, {3, 1, 2});
    write_test({2, 1, 3, 4}, {3, 1, 4, 2}, {4, 1, 2, 3});

    eprintf("min tests\n");
    write_test({1}, {1}, {1});
    write_test({1, 2}, {1, 2}, {2, 1});

    random_test(6);
    random_test(8);
    random_test(10);

    int N = 100000;

    forn(_, 10)
    {
        int n = rnd.next(100, 1000);
        random_test(n);
        random_ok(n);
    }
    
    test_reverse(N);
    forn(i, 3)
    {
        random_diag(N);
    }
    straight_diag(N);
    reversed_diag(N);
    izban1(N);
    izban2(N);
    izban3(N);
    izban4(N);

    forn(_, 10)
    {
        int n = rnd.next(N/10, N);
        random_test(n);
        random_ok(n);
    }

    forn(_, 5)
    {
        random_test(N);
        random_ok(N);
    }
    forn(_, 5)
    {
        random_test2(N);
    }
    

    
    return 0;
}