#include <iostream>
#include <vector>
#include <deque>
#include <bitset>
#include <algorithm>

using namespace std;

const int MAXN = 50000;
const int LG = 16;
int up[LG][MAXN];

int main() {
#ifdef DEBUG
    freopen("input", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n, m, s;
    cin >> n >> m >> s;
    s--;
    vector<vector<int>> gr(n);
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        gr[a].push_back(b);
        gr[b].push_back(a);
    }

    vector<int> dst(n, n);

    deque<int> q;
    q.push_back(s);
    dst[s] = 0;
    up[0][s] = s;
    while (!q.empty()) {
        int u = q.front();
        q.pop_front();
        for (int v : gr[u]) {
            if (dst[u] + 1 < dst[v]) {
                dst[v] = dst[u] + 1;
                q.push_back(v);
                up[0][v] = u;
                for (int i = 1; i < LG; i++) {
                    up[i][v] = up[i - 1][up[i - 1][v]];
                }
            }
        }
    }

    vector<vector<int>> gr1(n);
    for (int i = 0; i < n; i++) {
        for (int j : gr[i]) {
            if (dst[j] == dst[i] + 1) {
                gr1[j].push_back(i);
            }
        }
    }

    vector<pair<int, int>> vs(n);
    for (int i = 0; i < n; i++) {
        vs[i] = {dst[i], i};
    }
    sort(vs.begin(), vs.end());

    vector<int> cnt(n + 1);
    for (int i = 0; i < n; i++) {
        cnt[dst[i]]++;
    }

    vector<int> pref(n + 2);
    for (int i = 0; i <= n; i++) {
        pref[i + 1] = pref[i] + cnt[i];
    }

    vector<bitset<MAXN>> go(n);
    for (int i = 0; i < n; i++) {
        int v = vs[i].second;
        go[v][i] = true;
        for (auto u : gr1[v]) {
            go[v] |= go[u];
        }
    }

    int q1;
    cin >> q1;
    while (q1--) {
        int v, k;
        cin >> v >> k;
        v--;
        if (dst[v] < k) {
            cout << "0\n";
            continue;
        }
        if (dst[v] == n) {
            cout << "0\n";
            continue;
        }

        auto gov = go[v];
        int d = dst[v] - k;
        gov <<= MAXN - pref[k + 1];
        gov >>= MAXN - pref[k + 1];
        gov >>= pref[k];
        gov <<= pref[k];
        if (gov.count() == 0) {
            cout << "0\n";
        } else if (gov.count() > 1) {
            cout << "-1\n";
        } else {
            int u = v;
            for (int i = LG - 1; i >= 0; i--) {
                if (d >= 1 << i) {
                    d -= 1 << i;
                    u = up[i][u];
                }
            }
            cout << u + 1 << "\n";
        }
    }

    return 0;
}
