#include <iostream>
#include <vector>
#include <algorithm>
#include <deque>

using namespace std;

int main() {
#ifdef DEBUG
    freopen("input", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n, m, s;
    cin >> n >> m >> s;
    s--;
    vector<vector<int>> gr(n);
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        gr[a].push_back(b);
        gr[b].push_back(a);
    }

    vector<vector<int>> d(n, vector<int> (n, 3 * n + 1));
    for (int i = 0; i < n; i++) {
        deque<int> q;
        q.push_back(i);
        d[i][i] = 0;
        while (!q.empty()) {
            int u = q.front();
            q.pop_front();
            for (int v : gr[u]) {
                if (d[i][u] + 1 < d[i][v]) {
                    d[i][v] = d[i][u] + 1;
                    q.push_back(v);
                }
            }
        }
    }

    int q;
    cin >> q;
    while (q--) {
        int t, k;
        cin >> t >> k;
        t--;

        vector<int> oks;
        for (int i = 0; i < n; i++) {
            if (d[s][i] == k && d[i][t] + k == d[s][t]) {
                oks.push_back(i);
            }
        }

        if (oks.size() == 1) {
            cout << oks[0] + 1 << "\n";
        } else if (oks.empty()) {
            cout << "0\n";
        } else {
            cout << "-1\n";
        }
    }

    return 0;
}
