#include <bits/stdc++.h>
#include "testlib.h"
#define ff first
#define ss second
#define szof(_x) ((int) (_x).size())

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const ll INFL = 1e18 + 123;
const double PI = atan2(0, -1);

int main(int argc, char* argv[]) {
	setName("compare two outputs");
	registerTestlibCmd(argc, argv);

	int n, m, k;
	n = inf.readInt(), m = inf.readInt(), k = inf.readInt();

	vector<int> graph(n);
	for (int i = 0; i < m; ++i) {
		int a = inf.readInt(), b = inf.readInt();
		--a; --b;
		graph[a] |= 1 << b;
		graph[b] |= 1 << a;
	}

	vector<int> is_good(1 << n);
	is_good[0] = 1;

	for (int i = 1; i < 1 << n; ++i) {
		int any = i & (-i);
		int who = 0;
		while (1 << (who + 1) <= any) {
			++who;
		}
		is_good[i] = is_good[i ^ any] && !(graph[who] & (i ^ any));
	}

	int jans = ans.readInt();
	int pans = ouf.readInt();

	if (pans != -1) {
		if (pans < 0) {
			quitf(_wa, "number of moves can't be negative");
		}

		if (pans > 100000) {
			quitf(_wa, "too many flights");
		}

		int maskl = (1 << n) - 1;
		int maskr = 0;
		int pos = 0;
		for (int i = 0; i < pans; ++i) {
			int move = 0;
			int q = ouf.readInt(0, k);
			set<int> was;
			for (int j = 0; j < q; ++j) {
				int who = ouf.readInt(1, n) - 1;
				if (was.count(who)) {
					quitf(_wa, "every person should be written at most once in every line");
				}
				was.insert(who);
				move |= 1 << who;
			}

			if (pos == 0) {
				if ((move & maskl) != move) {
					quitf(_wa, "all persons from the move #%d should be on left shore", i + 1);
				}
			} else {
				if ((move & maskr) != move) {
					quitf(_wa, "all persons from the move #%d should be on right shore", i + 1);
				}
			}

			maskl ^= move;
			maskr ^= move;
			pos ^= 1;

			if (pos == 0) {
				if (!is_good[maskr]) {
					quitf(_wa, "there should be no enemies among persons on right shore after %d-th move", i + 1);
				}
			} else {
				if (!is_good[maskl]) {
					quitf(_wa, "there should be no enemies among persons on left shore after %d-th move", i + 1);
				}
			}
		}

		if (pos != 1) {
			quitf(_wa, "conveyor ended up on left shore");
		}

		if (maskr != (1 << n) - 1) {
			quitf(_wa, "not all persons ended up on right shore");
		}
	}

	if (jans == -1 && pans != -1) {
		quitf(_fail, "participant found solution, but jury didn't");
	}

	if (jans != -1 && pans == -1) {
		quitf(_wa, "participant didn't find solution, but jury did");
	}

	if (jans == -1 && pans == -1) {
		quitf(_ok, "solution doesn't exist");
	}

	quitf(_ok, "participant found solution with %d moves (jury has solution with %d moves)", pans, jans);

	return 0;
}