#include "bits/stdc++.h"
#define ff first
#define ss second
#define szof(_x) ((int) (_x).size())
#define TASK_NAME ""

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const ll INFL = 1e18 + 123;
const double PI = atan2(0, -1);
mt19937 tw(960172);
ll rnd(ll x, ll y) { static uniform_int_distribution<ll> d; return d(tw) % (y - x + 1) + x; }

int n = 15, k = 5;
const int GENERATION_SIZE = 30, MUTATION_AMOUNT = 10, MUTATED_AMOUNT = 30, CROSSED_AMOUNT = 50;
const int TOTAL_TIME = 1000;

struct graph {
	vector<int> m;
	graph() : m(n) {}
	bool operator<(graph const& other) const {
		return m < other.m;
	}
	bool operator==(graph const& other) const {
		return m == other.m;
	}
};

graph mutation(graph g) {
	if (rnd(0, k * (k - 1) / 2 + (n - k) * k - 1) < k * (k - 1) / 2) {
		int x = rnd(0, k - 1);
		int y = rnd(0, k - 2);
		if (y >= x) {
			y++;
		}
		if (x > y) {
			swap(x, y);
		}
		g.m[x] ^= 1 << y;
	} else {
		int x = rnd(0, k - 1);
		int y = rnd(k, n);
		g.m[x] ^= 1 << y;
	}
	return g;
}

graph cross(graph g1, graph const& g2) {
	for (int i = 0; i < k; ++i) {
		for (int j = i + 1; j < n; ++j) {
			if (((g1.m[i] ^ g2.m[i]) & (1 << j)) && rnd(0, 1)) {
				g1.m[i] ^= 1 << j;
			}
		}
	}
	return g1;
}

const int SZ = 1e5;
int from[SZ * 2];
int dist[SZ * 2];
int q[SZ * 2];
bool is_good[SZ];
int cnt_bits[SZ];
int arr_log[SZ];
map<vector<int>, pii> memory;

pii calc_quality(graph g) {
	if (memory.count(g.m)) {
		return memory[g.m];
	}
	auto& ret = memory[g.m];
	vector<int> gr(n);
	for (int i = 0; i < k; ++i) {
		for (int j = i + 1; j < n; ++j) {
			if (g.m[i] & (1 << j)) {
				gr[i] |= 1 << j;
				gr[j] |= 1 << i;
			}
		}
	}
	
	is_good[0] = 1;
	cnt_bits[0] = 0;
	for (int i = 1; i < 1 << n; ++i) {
		int any = i & (-i);
		cnt_bits[i] = cnt_bits[i ^ any] + 1;
		is_good[i] = is_good[i ^ any] && !((i ^ any) & gr[arr_log[any]]);
	}

	int l = 0, r = 0;
	q[r++] = 0;
	fill(from, from + SZ, -1);
	fill(dist, dist + SZ, INF);
	from[0] = -1;
	dist[0] = 0;
	int mask = (1 << n) - 1;
	int cnt = 0;
	while (l < r) {
		int cur = q[l++];
		int st = cur;
		//if (cur == ((mask << 1) | 1)) {
		//	break;
		//}
		++cnt;
		//cerr << st << endl;
		int where = cur & 1;
		cur >>= 1;
		if (!where) {
			cur = (~cur) & mask;
		}

		for (int move = cur; ; move = (move - 1) & cur) {
			//cerr << move << " " << cnt_bits[move] << " " << is_good[cur ^ move] << endl;
			if (cnt_bits[move] <= k && is_good[cur ^ move]) {
				int to = cur ^ move;
				if (!where) {
					to = (~to) & mask;
				}
				to = (to << 1) | (1 - where);
				if (dist[to] > dist[st] + 1) {
					dist[to] = dist[st] + 1;
					from[to] = st;
					q[r++] = to;
				}
			}

			if (move == 0) {
				break;
			}
		}
	}

	int f = (mask << 1) | 1;

	if (dist[f] == INF) {
		return ret = {INF, INF};
	}

	int cur = (mask << 1) | 1;
	vector<int> ans;
	while (cur != 0) {
		int tmp = from[cur];
		int moved = (tmp >> 1) ^ (cur >> 1);
		ans.push_back(moved);
		cur = tmp;
	}

	reverse(ans.begin(), ans.end());
	int tot = 0;
	//cout << szof(ans) << "\n";
	for (int i = 0; i < szof(ans) - 1; ++i) {
		tot += __builtin_popcount(ans[i] ^ ans[i + 1]);
	}

	return ret = {-tot, -dist[f]};
}

void solve() {
	vector<graph> generation;
	for (int i = 0; i < GENERATION_SIZE; ++i) {
		graph g;
		for (int x = 0; x < k; ++x) {
			for (int y = x + 1; y < n; ++y) {
				g.m[x] ^= rnd(0, 1) << y;
			}
		}
		generation.push_back(g);
	}


	for (int i = 0; i < TOTAL_TIME; ++i) {
		sort(generation.begin(), generation.end());
		generation.erase(unique(generation.begin(), generation.end()), generation.end());
		int mem = szof(generation);
		for (int j = 0; j < MUTATED_AMOUNT; ++j) {
			generation.push_back(mutation(generation[rnd(0, mem - 1)]));
		}
		for (int j = 0; j < CROSSED_AMOUNT; ++j) {
			generation.push_back(cross(generation[rnd(0, mem - 1)], generation[rnd(0, mem - 1)]));
		}
		vector<pair<pii, int>> quality;
		for (int j = 0; j < szof(generation); ++j) {
			quality.push_back({calc_quality(generation[j]), j});
		}
		sort(quality.begin(), quality.end());

		vector<graph> next;
		for (int j = 0; j < min(GENERATION_SIZE, szof(generation)); ++j) {
			next.push_back(generation[quality[j].ss]);
		}
		swap(next, generation);
		/*
		cerr << "generation #" << i + 1 << ", best quality is (" << quality.front().ff.ff << ", " << quality.front().ff.ss << ")\n";
		for (int x = 0; x < n; ++x) {
			for (int y = 0; y < n; ++y) {
				cerr << ((generation.front().m[x] >> y) & 1);
			}
			cerr << endl;
		}
		*/
		if (i == TOTAL_TIME - 1) {
			cerr << "generation #" << i + 1 << ", best quality is (" << quality.front().ff.ff << ", " << quality.front().ff.ss << ")\n";
			for (int x = 0; x < n; ++x) {
				for (int y = 0; y < n; ++y) {
					cerr << ((generation.front().m[x] >> y) & 1);
				}
				cerr << endl;
			}
		}
	}
	
		
	graph res = generation.front();
	vector<pii> edges;
	for (int i = 0; i < n; ++i) {
		for (int j = i + 1; j < n; ++j) {
			if (res.m[i] & (1 << j)) {
				edges.push_back({i, j});
			}
		}
	}
	cout << n << " " << szof(edges) << " " << k << "\n";
	for (pii e : edges) {
		cout << e.ff + 1 << " " << e.ss + 1 << "\n";
	}
}


int main(int argc, char* argv[]) {
	//freopen(TASK_NAME ".in", "r", stdin);
	//freopen(TASK_NAME ".out", "w", stdout);
	cerr << fixed << setprecision(15);
	cout << fixed << setprecision(15);
	ios::sync_with_stdio(false);

	assert(argc >= 3);
	n = atoi(argv[1]);
	k = atoi(argv[2]);


	for (int i = 0; i < n; ++i) {
		arr_log[1 << i] = i;
	}

	int tests = 1;
	// cin >> tests;
	for (int it = 1; it <= tests; ++it) {
		solve();
	}
	
	#ifdef LOCAL
		cerr << "time: " << clock() << " ms\n";
	#endif
	return 0;
}